//
// Written by: Bogdan Butoi
// Date: 05/06/96
//
// Copyright (c) May/1996 by Bogdan Butoi
//
// Last Modified: 07/03/96
//



import java.awt.*;
import java.applet.*;

public class tlifeGame extends Applet
{
        public tlifeGrid cel_grid;
        tlg_controls controls;
        //Button tools;

        public void init()
        {
                this.setLayout(new GridLayout(1,1));
                Graphics g=this.getGraphics();
                this.setBackground(Color.lightGray);
                cel_grid=new tlifeGrid(this.bounds());
                border(g,this.bounds());
                this.add(cel_grid);
                //tools=new Button("Show Controls");
                //add("South",tools);
                                
        };

        private void border(Graphics g, Rectangle r)
        {
                for (int i=0;i<2;i++)
                {
                        g.setColor(Color.white);
                        g.drawLine(r.x+i,r.y+i,r.x+r.width-i-1,r.y+i);
                        g.drawLine(r.x+i,r.y+i,r.x+i,r.y+r.height-i-1);
                        g.setColor(Color.gray);
                        g.drawLine(r.x+i,r.y+r.height-i-1,r.x+r.width-i-1,r.y+r.height-i-1);
                        g.drawLine(r.x+r.width-i-1,r.y+i,r.x+r.width-i-1,r.y+r.height-i-1);
                }
        };

        public boolean handleEvent(Event event)
        {
        if (event.id==Event.ACTION_EVENT)
        {
                if (event.target==cel_grid.basic_controls.tools)
                        if (cel_grid.show)
                        {
                                controls.dispose();
                                cel_grid.basic_controls.tools.setLabel("Show Controls");
                                cel_grid.show=false;
                                return true;
                        }
                        else
                        {       
                                controls = new tlg_controls("Life Game Controls",cel_grid);
                                controls.pack();
                                controls.show();
                                cel_grid.basic_controls.tools.setLabel("Hide Controls");
                                cel_grid.show=true;
                                return true;
                        }
                else
                if (event.target==cel_grid.basic_controls.next_10_button)
                {
                        for (int i=1;i<=10;i++)
                        {
                                cel_grid.next_step();
                                for (double j=0;j<100;j++);
                        }
                        return true;
                }
                else
                if (event.target==cel_grid.basic_controls.next_button)
                {
                                cel_grid.next_step();
                                return true;
                }
                else
                        return  super.handleEvent(event);
        }
        else
                return  super.handleEvent(event);
        }

        public void paint(Graphics g)
        {
                cel_grid.paint(g);
                border(this.getGraphics(),this.bounds());
        }

        public Insets insets()
        {
                return new Insets(10,10,10,10);
        }


}


class tlg_controls extends Frame
{

        public tlifeGrid outerparent;
        public tlifeGrid target;
        public Scrollbar dimension;
        public Scrollbar no_of_steps;
        public Scrollbar per_live_cells;
        public Label plc_label;
        public Label dim_label;
        public Button next_gen_button;
        public Button add_rnd;
        public Button clear_grid;
        public tsv_rcl_ctrl s_r_ct;

        
        tlg_controls(String title, tlifeGrid tgt)
        {
                super(title);

                this.outerparent = tgt;
                target=tgt;
                this.setLayout(new GridLayout(12,1,10,10));
                //add(new Label(" "));
                add(new Label(" "));
                dimension = new Scrollbar(Scrollbar.HORIZONTAL,target.dim,1,5,20);
                dim_label = new Label ("Dimension of the world: "+String.valueOf(target.dim)+
                                        "x"+String.valueOf(target.dim), Label.CENTER);
                add(dim_label);
                add (dimension);
                clear_grid = new Button("Clear the world");
                clear_grid.setBackground(Color.red);
                add (clear_grid);
                per_live_cells = new Scrollbar(Scrollbar.HORIZONTAL,target.rnd_cells,1,0,99);
                add(new Label ("% of locations randomly occupied",Label.CENTER));
                add (per_live_cells);
                add_rnd = new Button ("Occupy "+String.valueOf(target.rnd_cells)+"% of locations with life");
                add_rnd.setBackground(Color.blue);
                add_rnd.setForeground(Color.lightGray);
                add (add_rnd);
                add ( new Label ("Number of time steps to animate",Label.CENTER));
                no_of_steps = new Scrollbar(Scrollbar.HORIZONTAL,target.no_steps,1,1,100);
                add(no_of_steps);
                next_gen_button = new Button("Next "+String.valueOf(target.no_steps)+" time steps");
                next_gen_button.setBackground(Color.green);
                add (next_gen_button);
                s_r_ct= new tsv_rcl_ctrl();
                add(s_r_ct);
        }

        public boolean handleEvent(Event event)
        {
                if((event.id >=601) && (event.id <=605))
                {
                        if (event.target == this.dimension)
                        {
                                int dim=dimension.getValue();
                                dim_label.setText("Dimension of the world: "+String.valueOf(dim)+
                                                "x"+String.valueOf(dim));
                                target.cells_grid_resize((byte)dim);
                                return true;
                        }                       
                        else
                        if (event.target == this.no_of_steps)
                        {
                                int dim=no_of_steps.getValue();
                                if (dim==1)
                                        next_gen_button.setLabel("Next time step");
                                else
                                        next_gen_button.setLabel("Next "+String.valueOf(dim)+" time steps");
                                target.no_steps=dim;
                                return true;
                        }
                        else
                        if (event.target == this.per_live_cells)
                        {
                                int dim=per_live_cells.getValue();
                                add_rnd.setLabel("Occupy "+String.valueOf(dim)+"% of locations with life");
                                target.rnd_cells = dim;
                                return true;
                        }
                        else
                                return super.handleEvent(event);
                }                       
                else
                if (event.id == Event.ACTION_EVENT)
                {
                        if (event.target == next_gen_button)
                        {
                                for (int i=1;i<= target.no_steps;i++)
                                {
                                        target.next_step();
                                        for (double j=0;j<100;j++);
                                }               
                                return true;
                        }
                        else 
                        if (event.target == clear_grid)
                        {
                                target.clear_grid();
                                return true;
                        }
                        else
                        if (event.target == add_rnd)
                        {
                                target.add_live_cells();
                                return true;
                        }                               
                        else
                        if (event.target == s_r_ct.save_button)
                        {
                                target.save_my_grid();
                                return true;
                        }                               
                        else
                        if (event.target == s_r_ct.recall_button)
                        {
                                target.recall_grid();
                                return true;
                        }                               
                        else
                        if (event.target == s_r_ct.select_button)
                        {
                                this.dispose();
                                target.basic_controls.tools.setLabel("Show Controls");
                                target.show=false;
                                return true;
                        }                               
                        else
                                return super.handleEvent(event);
                }
                else
                        return super.handleEvent(event);
        }

        public Insets insets()
        {
                return new Insets(5,5,5,5);
        }
}

class tsv_rcl_ctrl extends Panel
{
        public Button save_button;
        public Button recall_button;
        public Button select_button;
        
        tsv_rcl_ctrl()
        {
                this.setLayout(new GridLayout(1,3,1,1));
                save_button=new Button("Save");
                recall_button=new Button("Recall");
                select_button = new Button("Close");
                add(save_button);
                add(recall_button);
                add(select_button);
        }

        public Insets insets()
        {
                return new Insets(1,1,1,1);
        }
}

class tbas_ctrl extends Panel
{
        Button tools;
        Button next_button;
        Button next_10_button;
        
        tbas_ctrl()
        {
                this.setLayout(new GridLayout(1,3,1,1));
                tools=new Button ("Show Controls");     
                next_button= new Button ("1 time step");
                add("South",next_button);
                next_10_button= new Button ("10 time steps");
                add("South",next_10_button);
                add("South",tools);
        }

        public Insets insets()
        {
                return new Insets(1,1,1,1);
        }
}


class tlifeGrid extends Panel
{

        byte dim=11;
        byte grid[][]=new byte[20][20];
        byte old_grid[][]=new byte[20][20];
        byte saved_grid[][]=new byte [20][20];
        int rnd_cells = 50;
        double radius;
        double sx;
        double sy;
        Graphics g;
        int no_steps=10;
        int oi=-1;
        int oj=-1;
        Rectangle r;
        boolean show=false;
        tbas_ctrl basic_controls;


        public tlifeGrid(Rectangle nr)
        {
                r=nr;
                g = getGraphics();
                setLayout(new BorderLayout(0,0));
                radius = (0.89*(r.height-10))/(2.2 * dim);
                sx = r.x+15;
                sy = r.y;
                basic_controls=new tbas_ctrl ();
                add("South",basic_controls);    
                
        };

        public void cells_grid_resize(byte new_dim)
        {
                dim= new_dim;
                radius =(0.89*(r.height-10))/(2.2 * dim);
                sx = r.x+15;
                sy = r.y;
                Rectangle area=this.bounds();
                g.clearRect(area.x-10,area.y-10,area.width+10,area.height+10);
                paint(getGraphics());
        }

        public void add_live_cells()
        {
                clear_grid();
                int no_cls = (int) (dim*dim*rnd_cells/100);
                for (int i=0;i<no_cls;i++)
                {
                        boolean flag = true;
                        do
                        {       
                                int ii = (int) Math.round(Math.random()*dim);
                                int ij = (int) Math.round(Math.random()*dim);
                                if ((ii>=0) && (ii<dim) && (ij>=0) && (ij<dim))
                                        if (grid[ii][ij]==0)
                                        {
                                                grid[ii][ij]=1;
                                                draw_cell( (int) (sx+radius*(2.2*ii+0.1)),
                                                   (int) (sy+radius*(2.2*ij+0.1)),
                                                    grid[ii][ij]);
                                                flag=false;
                                        }
                        } while (flag);
                }
        }

        public void save_grid()
        {
                for (int i=0;i<20;i++)
                        for (int j=0;j<20;j++)
                                old_grid[i][j]=grid[i][j];
        }

        public void clear_grid()
        {
                for (int i=0; i<20;i++)
                        for(int j=0;j<20;j++)
                                grid[i][j]=0;
                Rectangle area=this.bounds();
                g.clearRect(area.x,area.y,area.width,area.height);
                paint(getGraphics());
        }

        private void draw_cell(int cx,int cy, byte a)
        {
                g.setColor(Color.black);
                g.drawOval(cx,cy,(int)(2*radius),(int)(2*radius));
                if (a==1)
                        g.setColor(Color.green);
                else    
                        g.setColor(Color.red);
                g.fillOval(cx,cy,(int)(2*radius),(int)(2*radius));
        };


        public void save_my_grid()
        {
                for (int i = 0; i< dim; i++)
                        for (int j=0; j < dim; j++)
                                saved_grid[i][j]=grid[i][j];
        };


        public void recall_grid()
        {
                for (int i = 0; i< dim; i++)
                        for (int j=0; j < dim; j++)
                                grid[i][j]=saved_grid[i][j];
                paint(getGraphics());
        };


        public void paint(Graphics ng)
        {
                g = getGraphics();
                for (int i = 0; i< dim; i++)
                        for (int j=0; j < dim; j++)
                                draw_cell( (int) (sx+radius*(2.2*i+0.1)),
                                           (int) (sy+radius*(2.2*j+0.1)),
                                            grid[i][j]);
                //g.setColor(Color.black);
                //double lr=(0.7*r.height)/(2.2 * 20);
                //int lx=(int)(sx+lr*(2.2*2+0.1));
                //int ly=(int)(sy+lr*(2.2*21+0.1));
                //g.drawOval(lx,ly,(int)(lr*2),(int)(lr*2));
                //g.setColor(Color.green);
                //g.fillOval(lx,ly,(int)(2*lr),(int)(2*lr));
                //g.setColor(Color.black);
                //g.drawString("- Location occupied by life",lx+(int)(lr*3),ly+(int)(2*lr));
                //ly=(int)(sy+lr*(2.2*23+0.1));
                //g.drawString("- Unoccupied location",lx+(int)(lr*3),ly+(int)(2*lr));
                //g.drawOval(lx,ly,(int)(lr*2),(int)(lr*2));
                //g.setColor(Color.red);
                //g.fillOval(lx,ly,(int)(2*lr),(int)(2*lr));
        };      

        

        private boolean in_cell(int xc, int yc, int ii, int ij)
        {       
                double rdsq=radius*radius;
                double dist=Math.pow((Math.abs(xc)-sx-radius*(2.2*ii+1.1)),2) +         
                            Math.pow((Math.abs(yc)-sy-radius*(2.2*ij+1.1)),2);
                if (dist <= rdsq)
                        return true;
                else
                        return false;
        };

        public boolean mouseDown(Event e, int x, int y)
        {
                if ((x>=(int)sx-radius) && (x<= (int)(sx+(dim+1)*2.2*radius)) &&
                        (y>=(int)sy-radius) && (y<= (int)(sy+(dim+1)*2.2*radius)))
                for (int i=0;i<dim;i++)
                        for (int j=0;j<dim;j++)
                                if (in_cell(x,y,i,j))
                                {
                                        grid[i][j]=(byte) Math.pow((grid[i][j]-1),2);
                                        draw_cell ((int) (sx+radius*(2.2*i+0.1)),
                                                  (int) (sy+radius*(2.2*j+0.1)),
                                                  grid[i][j]);
                                        oi=i;
                                        oj=j;
                                }
                return true;
        };

        public boolean mouseDrag(Event e, int x, int y)
        {       
                if ((x>=(int)sx-radius) && (x<= (int)(sx+(dim+1)*2.2*radius)) &&
                        (y>=(int)sy-radius) && (y<= (int)(sy+(dim+1)*2.2*radius)))
                for (int i=0;i<dim;i++)
                        for (int j=0;j<dim;j++)
                                if (in_cell(x,y,i,j))
                                        if ((i!=oi) || (j!=oj))
                                        {       
                                                grid[i][j]=(byte) Math.pow((grid[i][j]-1),2);
                                                draw_cell ((int) (sx+radius*(2.2*i+0.1)),
                                                        (int) (sy+radius*(2.2*j+0.1)),
                                                         grid[i][j]);
                                                oi=i;
                                                oj=j;
                                        }
                return true;
        }

        private int no_neigh(int i, int j)
        {
                int n=0;
                for (int ni=-1;ni<2;ni++)
                        for (int nj=-1;nj<2;nj++)
                        {
                                int mi = i+ni;
                                int mj = j+nj;
                                if (mi < 0) 
                                        mi=dim+mi;
                                if (mi >= dim) 
                                        mi=mi-dim;
                                if (mj < 0) 
                                        mj=dim+mj;
                                if (mj >= dim) 
                                        mj=mj-dim;
                                n=n+old_grid[mi][mj];
                        }
                n=n-old_grid[i][j];
                return n;
        };

        public void next_step()
        {
                save_grid();
                for (int i=0; i<dim; i++)
                        for (int j=0; j<dim; j++)
                        {       
                                int n=no_neigh(i,j);
                                if ((old_grid[i][j]==1) && (n!=2) && (n!=3))
                                {
                                        grid[i][j]=0;
                                        draw_cell ((int) (sx+radius*(2.2*i+0.1)),
                                                  (int) (sy+radius*(2.2*j+0.1)),
                                                  grid[i][j]);
                                }
                                else
                                if ((old_grid[i][j]==0) && (n==3))
                                {
                                        grid[i][j]=1;
                                        draw_cell ((int) (sx+radius*(2.2*i+0.1)),
                                                  (int) (sy+radius*(2.2*j+0.1)),
                                                  grid[i][j]);
                                }
                        }
        };

        public boolean handleEvent(Event event)
        {
                return super.handleEvent(event);
        };



}


